#include "interrupts.h"
#include "kpanic.h"

#include <stdint.h>

void exception_handler(void)
{
	int8_t index = -1;
	__asm__ volatile("movb %%bl, %0" ::"m"(index));

	switch (index) {
	case 0:
		kpanic("interrupt: division by zero\n");
		break;
	case 1:
		kpanic("interrupt: debugger\n");
		break;
	case 2:
		kpanic("interrupt: NMI\n");
		break;
	case 3:
		kpanic("interrupt: breakpoint\n");
		break;
	case 4:
		kpanic("interrupt: overflow\n");
		break;
	case 5:
		kpanic("interrupt: bounds\n");
		break;
	case 6:
		kpanic("interrupt: invalid opcode\n");
		break;
	case 7:
		kpanic("interrupt: coprocessor not available\n");
		break;
	case 8:
		kpanic("interrupt: double fault\n");
		break;
	case 9:
		kpanic("interrupt: coprocessor segement overrun\n");
		break;
	case 10:
		kpanic("interrupt: invalid task state segment\n");
		break;
	case 11:
		kpanic("interrupt: segment not present\n");
		break;
	case 12:
		kpanic("interrupt: stack fault\n");
		break;
	case 13:
		kpanic("interrupt: general protection fault\n");
		break;
	case 14:
		kpanic("interrupt: page fault\n");
		break;
	case 15:
		kpanic("interrupt: reserved\n");
		break;
	case 16:
		kpanic("interrupt: math fault\n");
		break;
	case 17:
		kpanic("interrupt: alignment check\n");
		break;
	case 18:
		kpanic("interrupt: machine check\n");
		break;
	case 19:
		kpanic("interrupt: SIMD floating point exception\n");
		break;
	default:
		return;
		break;
	}
}
